package Performance;

import AminoAcid.AminoAcid;
import Codon.Codon;
import DNA.DNA;
import Exceptions.GeneralException;
import Family.Family;
import Mayrose.Mayrose;
import Paper.Paper;
import RY.RY;
import WAG.WAG;
import java.io.IOException;
import java.lang.management.ManagementFactory;
import java.lang.management.MemoryPoolMXBean;
import java.lang.management.MemoryUsage;
import java.util.List;

public class Performance
{

    public static void main(String[] args) throws GeneralException, IOException
    {
        long start = System.currentTimeMillis();
        
        switch (args[0])
        {
            case "AminoAcid":
                AminoAcid.main(new String[0]);
                break;
            case "Codon":
                Codon.main(new String[0]);
                break;
            case "Family":
                Family.main(new String[0]);
                break;
            case "Mayrose":
                Mayrose.main(new String[0]);
                break;
            case "Paper":
                Paper.main(new String[0]);
                break;
            case "RY":
                RY.main(new String[0]);
                break;
            case "WAG":
                WAG.main(new String[0]);
                break;
            case "DNA":
            default:
                DNA.main(new String[0]);
                break;
        }
        
        
        long end = System.currentTimeMillis();
        
        long mem = 0;
        List<MemoryPoolMXBean> pools = ManagementFactory.getMemoryPoolMXBeans();
        for (MemoryPoolMXBean pool : pools) 
        {
            MemoryUsage peak = pool.getPeakUsage();
            mem += peak.getUsed();
        }
        
        double memMB = ((double) mem) / (1024.0 * 1024.0);
        
        System.out.println(String.format("Memory: %8.2f MB", memMB));
        
        double runTime = (double) (end - start) / 1000.0;
        System.out.println(String.format("Run time: %8.1f seconds", runTime));
    }
    
}
